#ifndef _LCD_H_
#define _LCD_H_


//----- defines -----
#define LCD_DDR				DDRB 	//lcd ddr
#define LCD_PORT			PORTB 	//lcd port
#define LCD_RS_PIN			B0 		//lcd command / data write
#define LCD_SCK_PIN			B1		//lcd spi sck
#define LCD_MOSI_PIN		B2 		//lcd spi mosi
#define LCD_CSA_PIN			B4 		//lcd chip a enable
#define LCD_CSB_PIN			B5 		//lcd chip b enable
#define LCD_RESET_PIN		B6 		//lcd reset

#define LCD_CONTRAST_MIN	30
#define LCD_CONTRAST_MAX	50

#define LCD_CHIP_A			B0
#define LCD_CHIP_B			B1
#define LCD_CHIP_AB			(B0|B1)

#define LCD_RESET_OFF()		LCD_PORT |=  LCD_RESET_PIN 				//reset off
#define LCD_RESET()			LCD_PORT &= ~LCD_RESET_PIN				//reset on
#define LCD_CS_A()			LCD_PORT &= ~LCD_CSA_PIN 				//select A
#define LCD_CS_A_OFF()		LCD_PORT |=  LCD_CSA_PIN 				//deselect A
#define LCD_CS_B()			LCD_PORT &= ~LCD_CSB_PIN 				//select B
#define LCD_CS_B_OFF()		LCD_PORT |=  LCD_CSB_PIN 				//deselect B
#define LCD_CS_OFF()		LCD_PORT |=  LCD_CSA_PIN|LCD_CSB_PIN 	//deselect A && B
#define LCD_DATA()			LCD_PORT |=  LCD_RS_PIN 				//RS=1 (data)
#define LCD_CMD()			LCD_PORT &= ~LCD_RS_PIN		 			//RS=0 (cmd)


//----- prototypes -----
void 						lcd_init(UINT8 contrast, UINT8 invert);
inline void 				lcd_spi_write(UINT8 c);
inline void				lcd_write(UINT8 c, UINT8 chip);
inline void				lcd_data(UINT8 c, UINT8 chip);
inline void				lcd_cmd(UINT8 c, UINT8 chip);
void						lcd_clear(void);


#endif //_LCD_H_
